<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>learn-css</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      Web pages are built with HTML, which specifies the content of a page. CSS
      (Cascading Style Sheets) is a separate language which specifies a page’s
      <strong>appearance</strong>.
    </p>
    <p>
      CSS code is made of static <em>rules</em>. Each rule takes one or more
      <em>selectors</em> and gives specific <em>values</em> to a number of
      visual <em>properties</em>. Those properties are then applied to the page
      elements indicated by the selectors.
    </p>
    <p>
      This guide has been written with CSS 2 in mind, which is extended by the
      new features of CSS 3.
    </p>
    <p>
      <strong>NOTE:</strong> Because CSS produces visual results, in order to
      learn it, you need to try everything in a CSS playground like
      <a href="http://dabblet.com/">dabblet</a>. The main focus of this article
      is on the syntax and some general tips.
    </p>
    <h2 id="syntax">Syntax</h2>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode css"
      ><code class="sourceCode css"><a class="sourceLine" id="cb1-1" title="1"><span class="co">/* comments appear inside slash-asterisk, just like this line!</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co">   there are no &quot;one-line comments&quot;; this is the only comment style */</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">/* ####################</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="co">   ## SELECTORS</span></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="co">   #################### */</span></a>
<a class="sourceLine" id="cb1-7" title="7"></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="co">/* the selector is used to target an element on a page. */</span></a>
<a class="sourceLine" id="cb1-9" title="9">selector {</a>
<a class="sourceLine" id="cb1-10" title="10">  property: value<span class="op">;</span> <span class="co">/* more properties...*/</span></a>
<a class="sourceLine" id="cb1-11" title="11">}</a>
<a class="sourceLine" id="cb1-12" title="12"></a>
<a class="sourceLine" id="cb1-13" title="13"><span class="co">/*</span></a>
<a class="sourceLine" id="cb1-14" title="14"><span class="co">Here is an example element:</span></a>
<a class="sourceLine" id="cb1-15" title="15"></a>
<a class="sourceLine" id="cb1-16" title="16"><span class="co">&lt;div class=&#39;class1 class2&#39; id=&#39;anID&#39; attr=&#39;value&#39; otherAttr=&#39;en-us foo bar&#39; /&gt;</span></a>
<a class="sourceLine" id="cb1-17" title="17"><span class="co">*/</span></a>
<a class="sourceLine" id="cb1-18" title="18"></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="co">/* You can target it using one of its CSS classes */</span></a>
<a class="sourceLine" id="cb1-20" title="20"><span class="fu">.class1</span> {</a>
<a class="sourceLine" id="cb1-21" title="21">}</a>
<a class="sourceLine" id="cb1-22" title="22"></a>
<a class="sourceLine" id="cb1-23" title="23"><span class="co">/* or both classes! */</span></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="fu">.class1.class2</span> {</a>
<a class="sourceLine" id="cb1-25" title="25">}</a>
<a class="sourceLine" id="cb1-26" title="26"></a>
<a class="sourceLine" id="cb1-27" title="27"><span class="co">/* or its name */</span></a>
<a class="sourceLine" id="cb1-28" title="28">div {</a>
<a class="sourceLine" id="cb1-29" title="29">}</a>
<a class="sourceLine" id="cb1-30" title="30"></a>
<a class="sourceLine" id="cb1-31" title="31"><span class="co">/* or its id */</span></a>
<a class="sourceLine" id="cb1-32" title="32"><span class="pp">#anID</span> {</a>
<a class="sourceLine" id="cb1-33" title="33">}</a>
<a class="sourceLine" id="cb1-34" title="34"></a>
<a class="sourceLine" id="cb1-35" title="35"><span class="co">/* or using the fact that it has an attribute! */</span></a>
<a class="sourceLine" id="cb1-36" title="36"><span class="ex">[attr]</span> {</a>
<a class="sourceLine" id="cb1-37" title="37">  <span class="kw">font-size</span>: <span class="dv">smaller</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-38" title="38">}</a>
<a class="sourceLine" id="cb1-39" title="39"></a>
<a class="sourceLine" id="cb1-40" title="40"><span class="co">/* or that the attribute has a specific value */</span></a>
<a class="sourceLine" id="cb1-41" title="41"><span class="ex">[attr</span><span class="op">=</span><span class="st">&quot;value&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-42" title="42">  <span class="kw">font-size</span>: <span class="dv">smaller</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-43" title="43">}</a>
<a class="sourceLine" id="cb1-44" title="44"></a>
<a class="sourceLine" id="cb1-45" title="45"><span class="co">/* starts with a value (CSS 3) */</span></a>
<a class="sourceLine" id="cb1-46" title="46"><span class="ex">[attr</span><span class="op">^=</span><span class="st">&quot;val&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-47" title="47">  <span class="kw">font-size</span>: <span class="dv">smaller</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-48" title="48">}</a>
<a class="sourceLine" id="cb1-49" title="49"></a>
<a class="sourceLine" id="cb1-50" title="50"><span class="co">/* or ends with a value (CSS 3) */</span></a>
<a class="sourceLine" id="cb1-51" title="51"><span class="ex">[attr</span><span class="op">$=</span><span class="st">&quot;ue&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-52" title="52">  <span class="kw">font-size</span>: <span class="dv">smaller</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-53" title="53">}</a>
<a class="sourceLine" id="cb1-54" title="54"></a>
<a class="sourceLine" id="cb1-55" title="55"><span class="co">/* or contains a value in a space-separated list */</span></a>
<a class="sourceLine" id="cb1-56" title="56"><span class="ex">[otherAttr</span><span class="op">~=</span><span class="st">&quot;foo&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-57" title="57">}</a>
<a class="sourceLine" id="cb1-58" title="58"><span class="ex">[otherAttr</span><span class="op">~=</span><span class="st">&quot;bar&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-59" title="59">}</a>
<a class="sourceLine" id="cb1-60" title="60"></a>
<a class="sourceLine" id="cb1-61" title="61"><span class="co">/* or contains a value in a dash-separated list, e.g., &quot;-&quot; (U+002D) */</span></a>
<a class="sourceLine" id="cb1-62" title="62"><span class="ex">[otherAttr</span><span class="op">|=</span><span class="st">&quot;en&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-63" title="63">  <span class="kw">font-size</span>: <span class="dv">smaller</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-64" title="64">}</a>
<a class="sourceLine" id="cb1-65" title="65"></a>
<a class="sourceLine" id="cb1-66" title="66"><span class="co">/* You can combine different selectors to create a more focused selector. Don&#39;t</span></a>
<a class="sourceLine" id="cb1-67" title="67"><span class="co">   put spaces between them. */</span></a>
<a class="sourceLine" id="cb1-68" title="68">div<span class="fu">.some-class</span><span class="ex">[attr</span><span class="op">$=</span><span class="st">&quot;ue&quot;</span><span class="ex">]</span> {</a>
<a class="sourceLine" id="cb1-69" title="69">}</a>
<a class="sourceLine" id="cb1-70" title="70"></a>
<a class="sourceLine" id="cb1-71" title="71"><span class="co">/* You can select an element which is a child of another element */</span></a>
<a class="sourceLine" id="cb1-72" title="72">div<span class="fu">.some-parent</span> <span class="op">&gt;</span> <span class="fu">.class-name</span> {</a>
<a class="sourceLine" id="cb1-73" title="73">}</a>
<a class="sourceLine" id="cb1-74" title="74"></a>
<a class="sourceLine" id="cb1-75" title="75"><span class="co">/* or a descendant of another element. Children are the direct descendants of</span></a>
<a class="sourceLine" id="cb1-76" title="76"><span class="co">   their parent element, only one level down the tree. Descendants can be any</span></a>
<a class="sourceLine" id="cb1-77" title="77"><span class="co">   level down the tree. */</span></a>
<a class="sourceLine" id="cb1-78" title="78">div<span class="fu">.some-parent</span> <span class="fu">.class-name</span> {</a>
<a class="sourceLine" id="cb1-79" title="79">}</a>
<a class="sourceLine" id="cb1-80" title="80"></a>
<a class="sourceLine" id="cb1-81" title="81"><span class="co">/* Warning: the same selector without a space has another meaning.</span></a>
<a class="sourceLine" id="cb1-82" title="82"><span class="co">   Can you guess what? */</span></a>
<a class="sourceLine" id="cb1-83" title="83">div<span class="fu">.some-parent.class-name</span> {</a>
<a class="sourceLine" id="cb1-84" title="84">}</a>
<a class="sourceLine" id="cb1-85" title="85"></a>
<a class="sourceLine" id="cb1-86" title="86"><span class="co">/* You may also select an element based on its adjacent sibling */</span></a>
<a class="sourceLine" id="cb1-87" title="87"><span class="fu">.i-am-just-before</span> <span class="op">+</span> <span class="fu">.this-element</span> {</a>
<a class="sourceLine" id="cb1-88" title="88">}</a>
<a class="sourceLine" id="cb1-89" title="89"></a>
<a class="sourceLine" id="cb1-90" title="90"><span class="co">/* or any sibling preceding it */</span></a>
<a class="sourceLine" id="cb1-91" title="91"><span class="fu">.i-am-any-element-before</span> <span class="op">~</span> <span class="fu">.this-element</span> {</a>
<a class="sourceLine" id="cb1-92" title="92">}</a>
<a class="sourceLine" id="cb1-93" title="93"></a>
<a class="sourceLine" id="cb1-94" title="94"><span class="co">/* There are some selectors called pseudo classes that can be used to select an</span></a>
<a class="sourceLine" id="cb1-95" title="95"><span class="co">   element only when it is in a particular state */</span></a>
<a class="sourceLine" id="cb1-96" title="96"></a>
<a class="sourceLine" id="cb1-97" title="97"><span class="co">/* for example, when the cursor hovers over an element */</span></a>
<a class="sourceLine" id="cb1-98" title="98">selector<span class="in">:hover</span> {</a>
<a class="sourceLine" id="cb1-99" title="99">}</a>
<a class="sourceLine" id="cb1-100" title="100"></a>
<a class="sourceLine" id="cb1-101" title="101"><span class="co">/* or a link has been visited */</span></a>
<a class="sourceLine" id="cb1-102" title="102">selector<span class="in">:visited</span> {</a>
<a class="sourceLine" id="cb1-103" title="103">}</a>
<a class="sourceLine" id="cb1-104" title="104"></a>
<a class="sourceLine" id="cb1-105" title="105"><span class="co">/* or hasn&#39;t been visited */</span></a>
<a class="sourceLine" id="cb1-106" title="106">selected<span class="in">:link</span> {</a>
<a class="sourceLine" id="cb1-107" title="107">}</a>
<a class="sourceLine" id="cb1-108" title="108"></a>
<a class="sourceLine" id="cb1-109" title="109"><span class="co">/* or an element is in focus */</span></a>
<a class="sourceLine" id="cb1-110" title="110">selected<span class="in">:focus</span> {</a>
<a class="sourceLine" id="cb1-111" title="111">}</a>
<a class="sourceLine" id="cb1-112" title="112"></a>
<a class="sourceLine" id="cb1-113" title="113"><span class="co">/* any element that is the first child of its parent */</span></a>
<a class="sourceLine" id="cb1-114" title="114">selector<span class="in">:first-child</span> {</a>
<a class="sourceLine" id="cb1-115" title="115">}</a>
<a class="sourceLine" id="cb1-116" title="116"></a>
<a class="sourceLine" id="cb1-117" title="117"><span class="co">/* any element that is the last child of its parent */</span></a>
<a class="sourceLine" id="cb1-118" title="118">selector<span class="in">:last-child</span> {</a>
<a class="sourceLine" id="cb1-119" title="119">}</a>
<a class="sourceLine" id="cb1-120" title="120"></a>
<a class="sourceLine" id="cb1-121" title="121"><span class="co">/* Just like pseudo classes, pseudo elements allow you to style certain parts of</span></a>
<a class="sourceLine" id="cb1-122" title="122"><span class="co">    a document  */</span></a>
<a class="sourceLine" id="cb1-123" title="123"></a>
<a class="sourceLine" id="cb1-124" title="124"><span class="co">/* matches a virtual first child of the selected element */</span></a>
<a class="sourceLine" id="cb1-125" title="125">selector<span class="in">::before</span> {</a>
<a class="sourceLine" id="cb1-126" title="126">}</a>
<a class="sourceLine" id="cb1-127" title="127"></a>
<a class="sourceLine" id="cb1-128" title="128"><span class="co">/* matches a virtual last child of the selected element */</span></a>
<a class="sourceLine" id="cb1-129" title="129">selector<span class="in">::after</span> {</a>
<a class="sourceLine" id="cb1-130" title="130">}</a>
<a class="sourceLine" id="cb1-131" title="131"></a>
<a class="sourceLine" id="cb1-132" title="132"><span class="co">/* At appropriate places, an asterisk may be used as a wildcard to select every</span></a>
<a class="sourceLine" id="cb1-133" title="133"><span class="co">   element */</span></a>
<a class="sourceLine" id="cb1-134" title="134"><span class="op">*</span> {</a>
<a class="sourceLine" id="cb1-135" title="135">} <span class="co">/* all elements */</span></a>
<a class="sourceLine" id="cb1-136" title="136"><span class="fu">.parent</span> <span class="op">*</span> {</a>
<a class="sourceLine" id="cb1-137" title="137">} <span class="co">/* all descendants */</span></a>
<a class="sourceLine" id="cb1-138" title="138"><span class="fu">.parent</span> <span class="op">&gt;</span> <span class="op">*</span> {</a>
<a class="sourceLine" id="cb1-139" title="139">} <span class="co">/* all children */</span></a>
<a class="sourceLine" id="cb1-140" title="140"></a>
<a class="sourceLine" id="cb1-141" title="141"><span class="co">/* Group any number of selectors to define styles that affect all selectors</span></a>
<a class="sourceLine" id="cb1-142" title="142"><span class="co">   in the group */</span></a>
<a class="sourceLine" id="cb1-143" title="143">selector1<span class="op">,</span></a>
<a class="sourceLine" id="cb1-144" title="144">selector2 {</a>
<a class="sourceLine" id="cb1-145" title="145">}</a>
<a class="sourceLine" id="cb1-146" title="146"></a>
<a class="sourceLine" id="cb1-147" title="147"><span class="co">/* ####################</span></a>
<a class="sourceLine" id="cb1-148" title="148"><span class="co">   ## PROPERTIES</span></a>
<a class="sourceLine" id="cb1-149" title="149"><span class="co">   #################### */</span></a>
<a class="sourceLine" id="cb1-150" title="150"></a>
<a class="sourceLine" id="cb1-151" title="151">selector {</a>
<a class="sourceLine" id="cb1-152" title="152">  <span class="co">/* Units of length can be absolute or relative. */</span></a>
<a class="sourceLine" id="cb1-153" title="153"></a>
<a class="sourceLine" id="cb1-154" title="154">  <span class="co">/* Relative units */</span></a>
<a class="sourceLine" id="cb1-155" title="155">  <span class="kw">width</span>: <span class="dv">50</span><span class="dt">%</span><span class="op">;</span> <span class="co">/* percentage of parent element width */</span></a>
<a class="sourceLine" id="cb1-156" title="156">  <span class="kw">font-size</span>: <span class="dv">2</span><span class="dt">em</span><span class="op">;</span> <span class="co">/* multiples of element&#39;s original font-size */</span></a>
<a class="sourceLine" id="cb1-157" title="157">  <span class="kw">font-size</span>: <span class="dv">2</span><span class="dt">rem</span><span class="op">;</span> <span class="co">/* or the root element&#39;s font-size */</span></a>
<a class="sourceLine" id="cb1-158" title="158">  <span class="kw">font-size</span>: <span class="dv">2</span><span class="dt">vw</span><span class="op">;</span> <span class="co">/* multiples of 1% of the viewport&#39;s width (CSS 3) */</span></a>
<a class="sourceLine" id="cb1-159" title="159">  <span class="kw">font-size</span>: <span class="dv">2</span><span class="dt">vh</span><span class="op">;</span> <span class="co">/* or its height */</span></a>
<a class="sourceLine" id="cb1-160" title="160">  <span class="kw">font-size</span>: <span class="dv">2</span>vmin<span class="op">;</span> <span class="co">/* whichever of a vh or a vw is smaller */</span></a>
<a class="sourceLine" id="cb1-161" title="161">  <span class="kw">font-size</span>: <span class="dv">2</span>vmax<span class="op">;</span> <span class="co">/* or greater */</span></a>
<a class="sourceLine" id="cb1-162" title="162"></a>
<a class="sourceLine" id="cb1-163" title="163">  <span class="co">/* Absolute units */</span></a>
<a class="sourceLine" id="cb1-164" title="164">  <span class="kw">width</span>: <span class="dv">200</span><span class="dt">px</span><span class="op">;</span> <span class="co">/* pixels */</span></a>
<a class="sourceLine" id="cb1-165" title="165">  <span class="kw">font-size</span>: <span class="dv">20</span><span class="dt">pt</span><span class="op">;</span> <span class="co">/* points */</span></a>
<a class="sourceLine" id="cb1-166" title="166">  <span class="kw">width</span>: <span class="dv">5</span><span class="dt">cm</span><span class="op">;</span> <span class="co">/* centimeters */</span></a>
<a class="sourceLine" id="cb1-167" title="167">  <span class="kw">min-width</span>: <span class="dv">50</span><span class="dt">mm</span><span class="op">;</span> <span class="co">/* millimeters */</span></a>
<a class="sourceLine" id="cb1-168" title="168">  <span class="kw">max-width</span>: <span class="dv">5</span><span class="dt">in</span><span class="op">;</span> <span class="co">/* inches */</span></a>
<a class="sourceLine" id="cb1-169" title="169"></a>
<a class="sourceLine" id="cb1-170" title="170">  <span class="co">/* Colors */</span></a>
<a class="sourceLine" id="cb1-171" title="171">  <span class="kw">color</span>: <span class="cn">#f6e</span><span class="op">;</span> <span class="co">/* short hex format */</span></a>
<a class="sourceLine" id="cb1-172" title="172">  <span class="kw">color</span>: <span class="cn">#ff66ee</span><span class="op">;</span> <span class="co">/* long hex format */</span></a>
<a class="sourceLine" id="cb1-173" title="173">  <span class="kw">color</span>: <span class="cn">tomato</span><span class="op">;</span> <span class="co">/* a named color */</span></a>
<a class="sourceLine" id="cb1-174" title="174">  <span class="kw">color</span>: <span class="fu">rgb(</span><span class="dv">255</span><span class="op">,</span> <span class="dv">255</span><span class="op">,</span> <span class="dv">255</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* as rgb values */</span></a>
<a class="sourceLine" id="cb1-175" title="175">  <span class="kw">color</span>: <span class="fu">rgb(</span><span class="dv">10</span><span class="dt">%</span><span class="op">,</span> <span class="dv">20</span><span class="dt">%</span><span class="op">,</span> <span class="dv">50</span><span class="dt">%</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* as rgb percentages */</span></a>
<a class="sourceLine" id="cb1-176" title="176">  <span class="kw">color</span>: <span class="fu">rgba(</span><span class="dv">255</span><span class="op">,</span> <span class="dv">0</span><span class="op">,</span> <span class="dv">0</span><span class="op">,</span> <span class="dv">0.3</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* as rgba values (CSS 3) Note: 0 &lt;= a &lt;= 1 */</span></a>
<a class="sourceLine" id="cb1-177" title="177">  <span class="kw">color</span>: <span class="dv">transparent</span><span class="op">;</span> <span class="co">/* equivalent to setting the alpha to 0 */</span></a>
<a class="sourceLine" id="cb1-178" title="178">  <span class="kw">color</span>: <span class="fu">hsl(</span><span class="dv">0</span><span class="op">,</span> <span class="dv">100</span><span class="dt">%</span><span class="op">,</span> <span class="dv">50</span><span class="dt">%</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* as hsl percentages (CSS 3) */</span></a>
<a class="sourceLine" id="cb1-179" title="179">  <span class="kw">color</span>: <span class="fu">hsla(</span><span class="dv">0</span><span class="op">,</span> <span class="dv">100</span><span class="dt">%</span><span class="op">,</span> <span class="dv">50</span><span class="dt">%</span><span class="op">,</span> <span class="dv">0.3</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* as hsl percentages with alpha */</span></a>
<a class="sourceLine" id="cb1-180" title="180"></a>
<a class="sourceLine" id="cb1-181" title="181">  <span class="co">/* Borders */</span></a>
<a class="sourceLine" id="cb1-182" title="182">  <span class="kw">border-width</span>: <span class="dv">5</span><span class="dt">px</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-183" title="183">  <span class="kw">border-style</span>: <span class="dv">solid</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-184" title="184">  <span class="kw">border-color</span>: <span class="cn">red</span><span class="op">;</span> <span class="co">/* similar to how background-color is set */</span></a>
<a class="sourceLine" id="cb1-185" title="185">  <span class="kw">border</span>: <span class="dv">5</span><span class="dt">px</span> <span class="dv">solid</span> <span class="cn">red</span><span class="op">;</span> <span class="co">/* this is a short hand approach for the same */</span></a>
<a class="sourceLine" id="cb1-186" title="186">  <span class="kw">border-radius</span>: <span class="dv">20</span><span class="dt">px</span><span class="op">;</span> <span class="co">/* this is a CSS3 property */</span></a>
<a class="sourceLine" id="cb1-187" title="187"></a>
<a class="sourceLine" id="cb1-188" title="188">  <span class="co">/* Images as backgrounds of elements */</span></a>
<a class="sourceLine" id="cb1-189" title="189">  <span class="kw">background-image</span>: <span class="fu">url(</span><span class="st">/img-path/img.jpg</span><span class="fu">)</span><span class="op">;</span> <span class="co">/* quotes inside url() optional */</span></a>
<a class="sourceLine" id="cb1-190" title="190"></a>
<a class="sourceLine" id="cb1-191" title="191">  <span class="co">/* Fonts */</span></a>
<a class="sourceLine" id="cb1-192" title="192">  <span class="kw">font-family</span>: Arial<span class="op">;</span></a>
<a class="sourceLine" id="cb1-193" title="193">  <span class="co">/* if the font family name has a space, it must be quoted */</span></a>
<a class="sourceLine" id="cb1-194" title="194">  <span class="kw">font-family</span>: <span class="st">&quot;Courier New&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-195" title="195">  <span class="co">/* if the first one is not found, the browser uses the next, and so on */</span></a>
<a class="sourceLine" id="cb1-196" title="196">  <span class="kw">font-family</span>: <span class="st">&quot;Courier New&quot;</span><span class="op">,</span> Trebuchet<span class="op">,</span> Arial<span class="op">,</span> <span class="dv">sans-serif</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-197" title="197">}</a></code></pre>
    </div>
    <h2 id="usage">Usage</h2>
    <p>Save a CSS stylesheet with the extension <code>.css</code>.</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb2-1" title="1"><span class="co">&lt;!-- You need to include the css file in your page&#39;s &lt;head&gt;. This is the</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="co">     recommended method. Refer to http://stackoverflow.com/questions/8284365 --&gt;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;stylesheet&quot;</span><span class="ot"> type=</span><span class="st">&quot;text/css&quot;</span><span class="ot"> href=</span><span class="st">&quot;path/to/style.css&quot;</span> <span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb2-4" title="4"></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="co">&lt;!-- You can also include some CSS inline in your markup. --&gt;</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="kw">&lt;style&gt;</span></a>
<a class="sourceLine" id="cb2-7" title="7">  a {</a>
<a class="sourceLine" id="cb2-8" title="8">    <span class="kw">color</span>: <span class="cn">purple</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-9" title="9">  }</a>
<a class="sourceLine" id="cb2-10" title="10"><span class="kw">&lt;/style&gt;</span></a>
<a class="sourceLine" id="cb2-11" title="11"></a>
<a class="sourceLine" id="cb2-12" title="12"><span class="co">&lt;!-- Or directly set CSS properties on the element. --&gt;</span></a>
<a class="sourceLine" id="cb2-13" title="13"><span class="kw">&lt;div</span><span class="ot"> style=</span><span class="st">&quot;border: 1px solid red;&quot;</span><span class="kw">&gt;&lt;/div&gt;</span></a></code></pre>
    </div>
    <h2 id="precedence-or-cascade">Precedence or Cascade</h2>
    <p>
      An element may be targeted by multiple selectors and may have a property
      set on it in more than once. In these cases, one of the rules takes
      precedence over others. Rules with a more specific selector take
      precedence over a less specific one, and a rule occurring later in the
      stylesheet overwrites a previous one (which also means that if two
      different linked stylesheets contain rules for an element and if the rules
      are of the same specificity, then order of linking would take precedence
      and the sheet linked latest would govern styling) .
    </p>
    <p>
      This process is called cascading, hence the name Cascading Style Sheets.
    </p>
    <p>Given the following CSS:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode css"
      ><code class="sourceCode css"><a class="sourceLine" id="cb3-1" title="1"><span class="co">/* A */</span></a>
<a class="sourceLine" id="cb3-2" title="2">p<span class="fu">.class1</span><span class="ex">[attr</span><span class="op">=</span><span class="st">&#39;value&#39;</span><span class="ex">]</span></a>
<a class="sourceLine" id="cb3-3" title="3"></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="co">/* B */</span></a>
<a class="sourceLine" id="cb3-5" title="5">p<span class="fu">.class1</span> {</a>
<a class="sourceLine" id="cb3-6" title="6">}</a>
<a class="sourceLine" id="cb3-7" title="7"></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="co">/* C */</span></a>
<a class="sourceLine" id="cb3-9" title="9">p<span class="fu">.class2</span> {</a>
<a class="sourceLine" id="cb3-10" title="10">}</a>
<a class="sourceLine" id="cb3-11" title="11"></a>
<a class="sourceLine" id="cb3-12" title="12"><span class="co">/* D */</span></a>
<a class="sourceLine" id="cb3-13" title="13">p {</a>
<a class="sourceLine" id="cb3-14" title="14">}</a>
<a class="sourceLine" id="cb3-15" title="15"></a>
<a class="sourceLine" id="cb3-16" title="16"><span class="co">/* E */</span></a>
<a class="sourceLine" id="cb3-17" title="17">p {</a>
<a class="sourceLine" id="cb3-18" title="18">  property: value <span class="at">!important</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-19" title="19">}</a></code></pre>
    </div>
    <p>and the following markup:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">&lt;p</span><span class="ot"> style=</span><span class="st">&quot;/*F*/ property:value;&quot;</span><span class="ot"> class=</span><span class="st">&quot;class1 class2&quot;</span><span class="ot"> attr=</span><span class="st">&quot;value&quot;</span><span class="kw">&gt;&lt;/p&gt;</span></a></code></pre>
    </div>
    <p>
      The precedence of style is as follows. Remember, the precedence is for
      each <strong>property</strong>, not for the entire block.
    </p>
    <ul>
      <li>
        <code>E</code> has the highest precedence because of the keyword
        <code>!important</code>. It is recommended that you avoid its usage.
      </li>
      <li><code>F</code> is next, because it is an inline style.</li>
      <li>
        <code>A</code> is next, because it is more “specific” than anything
        else. It has 3 specifiers: The name of the element <code>p</code>, its
        class <code>class1</code>, an attribute <code>attr='value'</code>.
      </li>
      <li>
        <code>C</code> is next, even though it has the same specificity as
        <code>B</code>. This is because it appears after <code>B</code>.
      </li>
      <li><code>B</code> is next.</li>
      <li><code>D</code> is the last one.</li>
    </ul>
    <h2 id="media-queries">Media Queries</h2>
    <p>
      CSS Media Queries are a feature in CSS 3 which allows you to specify when
      certain CSS rules should be applied, such as when printed, or when on a
      screen with certain dimensions or pixel density. They do not add to the
      selector’s specificity.
    </p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode css"
      ><code class="sourceCode css"><a class="sourceLine" id="cb5-1" title="1"><span class="co">/* A rule that will be used on all devices */</span></a>
<a class="sourceLine" id="cb5-2" title="2">h1 {</a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="kw">font-size</span>: <span class="dv">2</span><span class="dt">em</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="kw">color</span>: <span class="cn">white</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5">  <span class="kw">background-color</span>: <span class="cn">black</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-6" title="6">}</a>
<a class="sourceLine" id="cb5-7" title="7"></a>
<a class="sourceLine" id="cb5-8" title="8"><span class="co">/* change the h1 to use less ink on a printer */</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="im">@media</span> <span class="dv">print</span> {</a>
<a class="sourceLine" id="cb5-10" title="10">  h1 {</a>
<a class="sourceLine" id="cb5-11" title="11">    <span class="kw">color</span>: <span class="cn">black</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-12" title="12">    <span class="kw">background-color</span>: <span class="cn">white</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-13" title="13">  }</a>
<a class="sourceLine" id="cb5-14" title="14">}</a>
<a class="sourceLine" id="cb5-15" title="15"></a>
<a class="sourceLine" id="cb5-16" title="16"><span class="co">/* make the font bigger when shown on a screen at least 480px wide */</span></a>
<a class="sourceLine" id="cb5-17" title="17"><span class="im">@media</span> <span class="dv">screen</span> <span class="kw">and</span> (<span class="kw">min-width</span>: <span class="dv">480</span><span class="dt">px</span>) {</a>
<a class="sourceLine" id="cb5-18" title="18">  h1 {</a>
<a class="sourceLine" id="cb5-19" title="19">    <span class="kw">font-size</span>: <span class="dv">3</span><span class="dt">em</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-20" title="20">    <span class="kw">font-weight</span>: <span class="dv">normal</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-21" title="21">  }</a>
<a class="sourceLine" id="cb5-22" title="22">}</a></code></pre>
    </div>
    <p>
      Media queries can include these features: <code>width</code>,
      <code>height</code>, <code>device-width</code>,
      <code>device-height</code>, <code>orientation</code>,
      <code>aspect-ratio</code>, <code>device-aspect-ratio</code>,
      <code>color</code>, <code>color-index</code>, <code>monochrome</code>,
      <code>resolution</code>, <code>scan</code>, <code>grid</code>. Most of
      these features can be prefixed with <code>min-</code> or
      <code>max-</code>.
    </p>
    <p>
      The <code>resolution</code> feature is not supported by older devices,
      instead use <code>device-pixel-ratio</code>.
    </p>
    <p>
      Many smartphones and tablets will attempt to render the page as if it were
      on a desktop unless you provide a <code>viewport</code> meta-tag.
    </p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">&lt;head&gt;</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;viewport&quot;</span><span class="ot"> content=</span><span class="st">&quot;width=device-width; initial-scale=1.0&quot;</span> <span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="kw">&lt;/head&gt;</span></a></code></pre>
    </div>
    <h2 id="compatibility">Compatibility</h2>
    <p>
      Most of the features in CSS 2 (and many in CSS 3) are available across all
      browsers and devices. But it’s always good practice to check before using
      a new feature.
    </p>
    <h2 id="resources">Resources</h2>
    <ul>
      <li>
        <a href="http://caniuse.com">CanIUse</a> (Detailed compatibility info)
      </li>
      <li><a href="http://dabblet.com/">Dabblet</a> (CSS playground)</li>
      <li>
        <a href="https://developer.mozilla.org/en-US/docs/Web/CSS"
          >Mozilla Developer Network’s CSS documentation</a
        >
        (Tutorials and reference)
      </li>
      <li>
        <a href="http://tympanus.net/codrops/css_reference/"
          >Codrops’ CSS Reference</a
        >
        (Reference)
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLqGj3iMvMa4IOmy04kDxh_hqODMqoeeCy"
          >DevTips’ CSS Basics</a
        >
        (Tutorials)
      </li>
    </ul>
    <h2 id="further-reading">Further Reading</h2>
    <ul>
      <li>
        <a
          href="http://www.vanseodesign.com/css/css-specificity-inheritance-cascaade/"
          >Understanding Style Precedence in CSS: Specificity, Inheritance, and
          the Cascade</a
        >
      </li>
      <li>
        <a href="https://css-tricks.com/almanac/selectors/a/attribute/"
          >Selecting elements using attributes</a
        >
      </li>
      <li><a href="http://www.quirksmode.org/css/">QuirksMode CSS</a></li>
      <li>
        <a
          href="https://developer.mozilla.org/en-US/docs/Web/Guide/CSS/Understanding_z_index/The_stacking_context"
          >Z-Index - The stacking context</a
        >
      </li>
      <li>
        <a href="http://sass-lang.com/">SASS</a> and
        <a href="http://lesscss.org/">LESS</a> for CSS pre-processing
      </li>
      <li><a href="https://css-tricks.com">CSS-Tricks</a></li>
    </ul>
  </body>
</html>
